﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_find_file_locker
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Select the executable file.
        private void Form1_Load(object sender, EventArgs e)
        {
            txtFile.Text = Application.ExecutablePath;
        }

        // Let the user pick a file to study.
        private void btnPickFile_Click(object sender, EventArgs e)
        {
            if (ofdLockedFile.ShowDialog() == DialogResult.OK)
                txtFile.Text = ofdLockedFile.FileName;
        }

        // Find any locks on the indicated file.
        private void btnFindLocks_Click(object sender, EventArgs e)
        {
            try
            {
                lstLockers.Items.Clear();

                // Get the processes.
                List<Process> lockers = LockTools.FindLockers(txtFile.Text);

                // Display the process names.
                foreach (Process process in lockers)
                    lstLockers.Items.Add(process.ProcessName);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
